merge {base} | R Documentation

## Merge Two Data Frames

### Description

Merge two data frames by common columns or row names.

### Usage

    merge(x, y, by, by.x, by.y, sort = TRUE)

### Arguments

`x, y` | data frames, or objects to be coerced to one
`by, by.x, by.y` | specifcations of the common columns. See Details.
`sort` | logical. Should the results be sorted on the `by` columns?

### Details

By default the data frames are merged on the columns with names they both have, but separate specifcations of the columns can be given by `by.x` and `by.y`. Columns can be specified by name, number or by a logical vector: the name `"row.names"` or the number `0` specifies the row names. The rows in the two data frames that match on the specified columns are extracted, and joined together. If there is more than one match, all possible matches contribute one row each.

If the remaining columns in the data frames have any common names, these have `".x"` and `".y"` appended to make the names of the result unique.

### Value

A data frame. The rows are by default lexicographically sorted on the common columns, but are otherwise in the order in which they occurred in `x`. The columns are the common columns followed by the remaining columns in `x` and then those in `y`. If the matching involved row names, an extra column `Row.names` is added at the left, and in all cases the result has no special row names.

### See Also

`data.frame`, `by`, `cbind`

### Examples

    authors <- data.frame(
        surname = c("Tukey", "Venables", "Tierney", "Ripley", "McNeil"),
        nationality = c("US", "Australia", "US", "UK", "Australia"),
        retired = c("yes", rep("no", 4)))
    books <- data.frame(
        name = c("Tukey", "Venables", "Tierney", "Ripley", "Ripley", "McNeil"),
        title = c("Exploratory Data Analysis",
                  "Modern Applied Statistics ...",
                  "LISP-STAT",
                  "Spatial Statistics", "Stochastic Simulation",
                   "Interactive Data Analysis"),
        other.author = c(NA, "Ripley", NA, NA, NA, NA))

    merge(authors, books, by.x="surname", by.y="name")
    merge(books, authors, by.x="name", by.y="surname")

[Package Contents]